Description

Since the goal of Foreman is to support life-cycle management, it should have support for doing business-specific tasks based.

For example, we generate custom SSL certificates for various services on each host we run.  While this could be accomplished in

Puppet, it seems that Foreman is the more logical place to control this behavior.

This could be accomplished via a plugin architecture or just an option of "script to run when creating a host" and "script to run when

deleting a host".

Related issues:

Related to Foreman - Feature #1353: Foreman should be able to handle pre and ... Closed 11/24/2011

Related to Foreman - Feature #58: trigger actions when a New sucessful host i... Closed 11/03/2009

History

#1 - 10/02/2011 11:28 AM - Ohad Levy

would a simple script executed by foreman user would suffice?

at the moment, since there are is no background processing in foreman, the request would block the UI (e.g. the UI would wait until the script would

finish)

#2 - 10/03/2011 01:17 PM - Benjamin Goldsbury

Seems fine to me.  Would be nice if Foreman could capture stdout/stderr and/or warn the user on a non-0 exit of the script.

#3 - 10/03/2011 03:07 PM - Ohad Levy

would you like to get a notice in the UI / email ?

who should be noticed? the owner of the host? the creator of the host?

#4 - 10/13/2011 09:19 AM - Benjamin Goldsbury

I think notification through the UI is a reasonable starting place.

#5 - 05/10/2012 03:32 AM - Ohad Levy

following a discussion on irc

here is an example http://pastie.org/3888211

#6 - 08/06/2012 03:55 PM - marcelo veglienzone

I would like to see something like this to have foreman update freeipa upon host creation

#7 - 12/16/2012 09:41 AM - Joseph Magen

You can implement hooking into host creation/deletion by writing a Foreman Plugin - http://theforeman.org/projects/foreman/wiki/Plugins

Just follow the example at http://theforeman.org/projects/foreman/wiki/How_to_Create_a_Plugin

https://github.com/isratrade/foreman_plugin_template/blob/master/app/models/foreman_plugin_template/host_extensions.rb
module HostExtensions

  extend ActiveSupport::Concern

  included do

    execute standard callbacks

    after_create :do_this

    after_destroy :do_that

    execute custom hooks

    after_ready_for_build :do_something_special_after_build

    def do_something_special_after_build

      p "doing customized callback something special AFTER build" 

    end

  end

end

#8 - 12/16/2012 10:42 AM - Ohad Levy

- Category set to Plugin integration

- Status changed from New to Resolved

- Assignee set to Joseph Magen

- Target version set to 1.1
